<?php

namespace MMO\Hide\BbCode\Tag;

class HideDays extends AbstractTag
{
    /**
     * @inheritDoc
     */
    public function render($content, array $tagChildren, $tagOption, array $tag, array $options)
    {
        $canView = false;
        $tagOptions = intval($tagOption);
        $user_date = intval((\XF::$time - $this->visitor()->register_date) / 86400);

        $title = \XF::phrase('mh_tag_days_x_y', [
            'days' => $tagOptions,
            'now_days' => $user_date
        ]);

        if ($tagOptions <= $user_date)
        {
            $canView = true;
        }

        return $this->renderTemplate($content, $title, [
            'canView' => $canView,
            'options' => $options,
            'tag' => $tag['tag']
        ]);
    }
}