<?php

namespace MMO\Hide\BbCode\Tag;

class HidePosts extends AbstractTag
{
    /**
     * @inheritDoc
     */
    public function render($content, array $tagChildren, $tagOption, array $tag, array $options)
    {
        $canView = false;
        $tagOptions = intval($tagOption);
        $posts_count = $this->visitor()->message_count;

        $title = \XF::phrase('mh_tag_posts_x_y', [
            'need_posts' => $tagOptions,
            'now_posts' => $posts_count
        ]);

        if($tagOptions <= $posts_count)
        {
            $canView = true;
        }

        return $this->renderTemplate($content, $title, [
            'canView' => $canView,
            'options' => $options,
            'tag' => $tag['tag']
        ]);
    }
}