<?php

namespace MMO\Hide;

use MMO\Hide\BbCode\HideTags;

class Listener
{
    /**
     * @param array $data
     * @param \XF\Mvc\Controller $controller
     */
    public static function editorDialog(array &$data, \XF\Mvc\Controller $controller)
    {
        if(in_array($data['dialog'], HideTags::getHideTags()))
        {
            $data['template'] = 'mh_hide_editor_dialog_' . $data['dialog'];
        }
    }

    /**
     * @param \XF\Container $container
     * @param \XF\Template\Templater $templater
     *
     * @throws \Exception
     */
    public static function templaterSetup(\XF\Container $container, \XF\Template\Templater &$templater)
    {
        /** @var \MMO\Hide\Template\TemplaterSetup $templaterSetup */
        $class = \XF::extendClass('MMO\Hide\Template\TemplaterSetup');
        $templaterSetup = new $class();

        $templater->addFunction('mh_react', [$templaterSetup, 'funcMhReact']);
    }

    /**
     * @param \XF\Template\Templater
     * @param $type
     * @param $template
     * @param array $params
     */
    public static function templaterTemplatePreRender(\XF\Template\Templater $templater, &$type, &$template, array &$params)
    {
        foreach (HideTags::getHideTags() as $tag)
        {
            if (!\XF::visitor()->canUseHideTag(ucfirst($tag)))
            {
                $params['removeButtons'][] = "xfCustom_{$tag}";
            }
        }

        $params['mhHide'] = HideTags::getHideTags();
    }
}